// This the header for application based on BTFBASE project
//

#ifndef __IBTFBASE_H__
#define __IBTFBASE_H__

extern void initBTFBASE(char *parName);

extern void finishBTFBASE();

extern void selectBTFMaterial(int materialIndex);

extern int getIndexOfSelectedBTFMaterial();
extern int getBTFMaterialCount();

extern void getSizeBTFBASE(int &rowsNum, int &colsNum);

extern const char* getBTFMaterialName();

extern void getBTFDeg(int irow, int jcol, float theta_i, float phi_i,
		      float theta_v, float phi_v, float RGB[]);

extern void getBTFRad(int irow, int jcol, float theta_i, float phi_i,
		      float theta_v, float phi_v, float RGB[]);

extern void getOrigBTFDeg(int irow, int jcol, float theta_i, float phi_i,
			  float theta_v, float phi_v, float RGB[]);
// For using more databases
extern void setBTFBASEpointer(void* newPointer);
extern void* getBTFBASEpointer();

// Make importance sampling
extern int importanceSamplingDegBTFBASE(int irow, int jcol, float theta_v, float phi_v,
					float q0, float q1, float &theta_i, float &phi_i);
extern int importanceSamplingDegBTFBASE(int irow, int jcol, float theta_v, float phi_v,
					int cntRays, float q0q1[], float theta_phi_i[]);

extern void getViewerAlbedoDegBTFBASE(int irow, int jcol, float theta_v, float phi_v, float RGB[]);

extern float getViewerDiffusenessDegBTFBASE(int irow, int jcol, float theta_v, float phi_v);

// Given the angle indices in the new onion parametrization, it returns the
// light direction theta_i, phi_i and viewer direction theta_v, phi_v in
// degrees. It returns 0 on success, 1 if indices are wrong!
extern int getParameterizationDegBTFBASE(int indexBeta, int indexAlpha, int indexThetaV, int indexPhiV,
					  float &theta_i, float &phi_i, float &theta_v, float &phi_v);

#endif //  __IBTFBASE_H__

