// ================================================================
// $Id: $
//
// vrmlsup.h
//
// Functions to make easy debugging via VRML'97 file format.
//
// Initial coding by Vlastimil Havran, 2005.

#ifndef __VRMLSUP_H__
#define __VRMLSUP_H__

// The stream to put VRML file for 3D visualization
//static ofstream VRMLStream;

// Color should be given in <0,1> range for r,g,b
extern void VRMLStreamPutPoint(const double x, double y, double z,
			       double r, double g, double b,
			       double radius = 0.01);

extern void VRMLStreamOpen(char *filename="debug.wrl");

extern void VRMLStreamSaveAxes(float cx, float cy, float cz, float length, double radius = 0.01);

// saves a line by spheres, given center cx,cy,cz,
// direction dx,dy,dz, length, radius
// x-axis is red, y-axis is green, z-axis is blue
extern void VRMLStreamSaveLine(float cx, float cy, float cz,
			       float dx, float dy, float dz,
			       float red, float green, float blue,
			       float length=1, float radius=0.01);
  
extern void VRMLStreamClose();

#endif // __VRMLSUP_H__
